#ifndef usluge_h
#define usluge_h

// Praksa je da se prvo navode korisnicki fajlovi i biblioteke, a tek onda ugradjene
#include "broj.h"
#include <string>
using namespace std;

// U redu je da klase koje su u istoj hijerarhiji nasledjivanja budu definisane u istom .h fajlu

class Usluga {
public:
	Usluga(const Broj& broj_od, const Broj& broj_ka);

	virtual double cena() const = 0;
	virtual void pisi() const;

protected:
	Broj broj_od_;
	Broj broj_ka_;
};

class Poziv : public Usluga {
public:
	Poziv(const Broj& broj_od, const Broj& broj_ka, int trajanje);

	double cena() const override;
	void pisi() const override;

private:
	// Uvedene simbolicke konstante
	static const int uspostavljanje_veze_domaci_saobracaj;
	static const int uspotavljanje_veze_inostranstvo;
	static const int zapoceti_minut_domaci_saobracaj;
	static const int zapoceti_minut_inostranstvo;

	int trajanje_;
};

class Poruka : public Usluga {
public:
	Poruka(const Broj& broj_od, const Broj& broj_ka, const string& tekst);

	double cena() const override;
	void pisi() const override;

private:
	static const int slanje_poruke_domaci_saobracaj;
	static const int slanje_poruke_inostranstvo;
	string tekst_;
};

#endif // !usluge_h
